## qimgv 0.9.1

=== CMakeLists.txt ===
# qimgv root
cmake_minimum_required(VERSION 3.13)
project(qimgv
    VERSION 0.8.9
    HOMEPAGE_URL "https://github.com/easymodo/qimgv"
    LANGUAGES CXX)

#if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
#    set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
#    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
#        Debug Release MinSizeRel RelWithDebInfo)
#endif()
message(STATUS "Build configuration: " ${CMAKE_BUILD_TYPE})

# detect if libstdc++ is in use to know if libstdc++fs should be linked
include(CheckCXXSourceCompiles)
check_cxx_source_compiles("#include <iostream>
    #ifndef __GLIBCXX__
    #error not using libstdc+++
    #endif
    int main() { return 0; }"
    USING_LIBSTDCXX)

# check requirements for std::filesystem
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND
        CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
    message(FATAL_ERROR "\n!!! THIS PROJECT REQUIRES GCC 8 OR LATER !!!\n"
        "If you already have gcc 8+ you can force it like this:\n"
        "CC=gcc-8 CXX=g++-8 cmake [...etc]")
    # force gcc 8
    #set(CMAKE_C_COMPILER "gcc-8")
    #set(CMAKE_CXX_COMPILER "g++-8")
endif()

# AUTOMOC
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# USER OPTIONS
# Usage: cmake -DVIDEO_SUPPORT=ON [...]
option(EXIV2 "For reading/writing exif tags" ON)
option(VIDEO_SUPPORT "Enable video support" ON)
option(OPENCV_SUPPORT "Enable HQ scaling via OpenCV" ON)
option(KDE_SUPPORT "Support blur when using KDE" OFF)

# FIND PACKAGES
find_package(Qt5 REQUIRED COMPONENTS Core Concurrent Widgets)

if(EXIV2)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Exiv2 REQUIRED IMPORTED_TARGET exiv2)
endif()

if(KDE_SUPPORT)
    find_package(KF5WindowSystem REQUIRED)
endif()

if(OPENCV_SUPPORT)
    find_package(PkgConfig REQUIRED)
    find_package(OpenCV REQUIRED core imgproc)
endif()

##############################################################

add_subdirectory(qimgv)

if(VIDEO_SUPPORT)
    add_subdirectory(qimgv_libs/qimgv_player_mpv)
endif()

=== qimgv/CMakeLists.txt ===
include(GNUInstallDirs)

# ADD EXECUTABLE
add_executable(qimgv
    appversion.cpp
    core.cpp
    main.cpp
    settings.cpp
    sharedresources.cpp
    shortcutbuilder.cpp
    proxystyle.cpp
    resources.qrc
    qimgv.rc)

# ADD SOURCES
add_subdirectory(components)
add_subdirectory(sourcecontainers)
add_subdirectory(gui)
add_subdirectory(utils)
if(OPENCV_SUPPORT)
    add_subdirectory(3rdparty/QtOpenCV)
endif()

# C++ STANDARD
target_compile_features(qimgv PRIVATE cxx_std_17)
set_target_properties(qimgv PROPERTIES CXX_EXTENSIONS OFF)

# LINK STUFF
target_link_libraries(qimgv PRIVATE Qt5::Core Qt5::Widgets Qt5::Concurrent)
if(USING_LIBSTDCXX)
    target_link_libraries(qimgv PRIVATE stdc++fs)
endif()

# OPTION DEFINITIONS, LINKING
if(EXIV2)
    target_link_libraries(qimgv PRIVATE PkgConfig::Exiv2)
    target_compile_definitions(qimgv PRIVATE USE_EXIV2)
endif()
if(KDE_SUPPORT)
    target_link_libraries(qimgv PRIVATE KF5::WindowSystem)
    target_compile_definitions(qimgv PRIVATE USE_KDE_BLUR)
endif()
if(VIDEO_SUPPORT)
    target_compile_definitions(qimgv PRIVATE USE_MPV)
endif()
if(OPENCV_SUPPORT)
    target_link_libraries(qimgv PRIVATE ${OpenCV_LIBS})
    target_compile_definitions(qimgv PRIVATE USE_OPENCV)
endif()

# generate proper GUI program on specified platform
if(WIN32) # Check if we are on Windows
    if(MSVC) # Check if we are using the Visual Studio compiler
        set_target_properties(qimgv PROPERTIES WIN32_EXECUTABLE ON)
        target_link_options(qimgv PRIVATE "/ENTRY:mainCRTStartup")
    elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        target_link_options(qimgv PRIVATE "-mwindows") # Not tested
    else()
        message(SEND_ERROR "You are using an unsupported Windows compiler! (Not MSVC or GCC)")
    endif(MSVC)
elseif(APPLE)
    set_target_properties(qimgv PROPERTIES MACOSX_BUNDLE YES)
elseif(NOT UNIX)
    message(SEND_ERROR "You are on an unsupported platform! (Not Win32, Mac OS X or Unix)")
endif()

## INSTALLATION
install(TARGETS qimgv
    DESTINATION bin)

# .desktop
install(FILES distrib/qimgv.desktop
    DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/applications)

# icons
foreach(icon IN ITEMS 16x16 22x22 24x24 32x32 36x36 48x48 64x64 128x128 256x256)
    install(FILES distrib/hicolor/${icon}/apps/qimgv.png DESTINATION
        ${CMAKE_INSTALL_FULL_DATAROOTDIR}/icons/hicolor/${icon}/apps)
endforeach()
install(FILES distrib/hicolor/scalable/apps/qimgv.svg
    DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/icons/hicolor/scalable/apps)

=== qimgv/components/CMakeLists.txt ===
## SOURCES FOR QIMGV COMPONENTS

target_sources(qimgv PRIVATE
    directorymodel.cpp
    directorypresenter.cpp

    scriptmanager/scriptmanager.cpp
    actionmanager/actionmanager.cpp

    cache/cache.cpp
    cache/cacheitem.cpp
    cache/thumbnailcache.cpp

    loader/loader.cpp
    loader/loaderrunnable.cpp

    scaler/scaler.cpp
    scaler/scalerrunnable.cpp

    thumbnailer/thumbnailer.cpp
    thumbnailer/thumbnailerrunnable.cpp

    directorymanager/directorymanager.cpp

    directorymanager/watchers/directorywatcher.cpp
    directorymanager/watchers/dummywatcher.cpp
    directorymanager/watchers/watcherevent.cpp
    directorymanager/watchers/watcherworker.cpp

)

if(UNIX)
    target_sources(qimgv PRIVATE
        directorymanager/watchers/linux/linuxfsevent.cpp
        directorymanager/watchers/linux/linuxwatcher.cpp
        directorymanager/watchers/linux/linuxworker.cpp)
elseif(WIN32)
    target_sources(qimgv PRIVATE
        directorymanager/watchers/windows/windowswatcher.cpp
        directorymanager/watchers/windows/windowsworker.cpp)
endif()

=== qimgv/gui/CMakeLists.txt ===
## SOURCES FOR QIMGV GUI

target_sources(qimgv PRIVATE
    centralwidget.cpp
    contextmenu.cpp
    flowlayout.cpp
    idirectoryview.cpp
    mainwindow.cpp

    customwidgets/actionbutton.cpp
    customwidgets/clickablelabel.cpp
    customwidgets/contextmenuitem.cpp
    customwidgets/floatingwidget.cpp
    customwidgets/floatingwidgetcontainer.cpp
    customwidgets/iconbutton.cpp
    customwidgets/iconwidget.cpp
    customwidgets/keysequenceedit.cpp
    customwidgets/menuitem.cpp
    customwidgets/overlaywidget.cpp
    customwidgets/pathselectormenuitem.cpp
    customwidgets/sidepanelwidget.cpp
    customwidgets/slidehpanel.cpp
    customwidgets/slidepanel.cpp
    customwidgets/slidevpanel.cpp
    customwidgets/spinboxinputfix.cpp
    customwidgets/thumbnailview.cpp
    customwidgets/thumbnailwidget.cpp
    customwidgets/videoslider.cpp
    customwidgets/pushbuttonfocusind.cpp

    dialogs/resizedialog.cpp
    dialogs/scripteditordialog.cpp
    dialogs/settingsdialog.cpp
    dialogs/shortcutcreatordialog.cpp

    overlays/changelogwindow.cpp
    overlays/controlsoverlay.cpp
    overlays/copyoverlay.cpp
    overlays/cropoverlay.cpp
    overlays/floatingmessage.cpp
    overlays/floatingmessageproxy.cpp
    overlays/fullscreeninfooverlay.cpp
    overlays/fullscreeninfooverlayproxy.cpp
    overlays/imageinfooverlay.cpp
    overlays/imageinfooverlayproxy.cpp
    overlays/mapoverlay.cpp
    overlays/renameoverlay.cpp
    overlays/saveconfirmoverlay.cpp
    overlays/videocontrols.cpp
    overlays/videocontrolsproxy.cpp
    overlays/zoomindicatoroverlay.cpp
    overlays/zoomindicatoroverlayproxy.cpp

    panels/croppanel/croppanel.cpp
    panels/mainpanel/mainpanel.cpp
    panels/mainpanel/thumbnailstrip.cpp
    panels/sidepanel/sidepanel.cpp

    panels/infobar/infobar.cpp
    panels/infobar/infobarproxy.cpp

    viewers/documentwidget.cpp
    viewers/imageviewerv2.cpp
    viewers/videoplayer.cpp
    viewers/videoplayerinitproxy.cpp
    viewers/viewerwidget.cpp

    folderview/foldergridview.cpp
    folderview/folderview.cpp
    folderview/folderviewproxy.cpp
    folderview/thumbnailgridwidget.cpp
    folderview/filesystemmodelcustom.cpp
    folderview/treeviewcustom.cpp
    folderview/bookmarkswidget.cpp
    folderview/bookmarksitem.cpp
)

# UI Files

target_sources(qimgv PRIVATE
    contextmenu.ui

    dialogs/resizedialog.ui
    dialogs/scripteditordialog.ui
    dialogs/settingsdialog.ui
    dialogs/shortcutcreatordialog.ui

    overlays/changelogwindow.ui
    overlays/copyoverlay.ui
    overlays/floatingmessage.ui
    overlays/fullscreeninfooverlay.ui
    overlays/imageinfooverlay.ui
    overlays/renameoverlay.ui
    overlays/saveconfirmoverlay.ui
    overlays/videocontrols.ui

    panels/croppanel/croppanel.ui
    panels/sidepanel/sidepanel.ui

    panels/infobar/infobar.ui

    folderview/folderview.ui
)

=== qimgv/sourcecontainers/CMakeLists.txt ===
## SOURCES FOR QIMGV CONTAINER CLASSES

target_sources(qimgv PRIVATE
    clip.cpp
    documentinfo.cpp
    image.cpp
    imageanimated.cpp
    imagestatic.cpp
    thumbnail.cpp
    video.cpp
)

=== qimgv/utils/CMakeLists.txt ===
## SOURCES FOR QIMGV UTILITY CLASSES

target_sources(qimgv PRIVATE
    actions.cpp
    helprunner.cpp
    imagefactory.cpp
    imagelib.cpp
    inputmap.cpp
    randomizer.cpp
    script.cpp
    sleep.cpp
    stuff.cpp
    wallpapersetter.cpp
)

=== qimgv_libs/qimgv_player_mpv/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)
project(qimgv_player_mpv VERSION 1.0
    DESCRIPTION "video player widget for qimgv (using mpv)"
    LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

find_package(Qt5 REQUIRED COMPONENTS Core Widgets)

find_package(PkgConfig REQUIRED)
pkg_check_modules(Mpv REQUIRED IMPORTED_TARGET mpv)

include(GNUInstallDirs)

add_library(qimgv_player_mpv SHARED
    src/videoplayer.cpp
    src/mpvwidget.cpp
    src/videoplayermpv.cpp
    src/qthelper.hpp)

target_compile_features(qimgv_player_mpv PRIVATE cxx_std_11)

target_link_libraries(qimgv_player_mpv PRIVATE
    Qt5::Core Qt5::Widgets PkgConfig::Mpv)

set_target_properties(qimgv_player_mpv PROPERTIES
    CXX_EXTENSIONS OFF
    VERSION ${PROJECT_VERSION}
    SOVERSION 1)

target_include_directories(qimgv_player_mpv PRIVATE src)

if(WIN32)
    target_include_directories(qimgv_player_mpv PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/mpv-dev/include)
    target_link_directories(qimgv_player_mpv PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/mpv-dev/$<IF$<EQUAL:${CMAKE_SIZEOF_VOID_P},8>,x86_64,i686>)
endif()

target_compile_definitions(qimgv_player_mpv PRIVATE QIMGV_PLAYER_MPV_LIBRARY)

install(TARGETS qimgv_player_mpv LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== debian/changelog ===
qimgv (0.9.1-2) unstable; urgency=medium

  * Source-only upload.
  * debian/rules: Enable full hardening. 

 -- Boyuan Yang <byang@debian.org>  Tue, 14 Jul 2020 08:07:34 -0400

qimgv (0.9.1-1) unstable; urgency=medium

  * Initial release. (Closes: #960198)

 -- Boyuan Yang <byang@debian.org>  Sat, 06 Jun 2020 10:47:48 -0400

=== debian/control ===
Source: qimgv
Section: graphics
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Standards-Version: 4.5.0
Build-Depends:
 debhelper-compat (= 13),
 pkg-config,
 qtbase5-dev (>= 5.9~),
 cmake (>= 3.13~),
 libmpv-dev,
 libkf5windowsystem-dev,
 libopencv-dev,
 libopencv-imgproc-dev,
 libopencv-core-dev,
 libexiv2-dev,
Rules-Requires-Root: no
Homepage: https://github.com/easymodo/qimgv
Vcs-Git: https://salsa.debian.org/multimedia-team/qimgv.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/qimgv

Package: qimgv
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Qt5 image viewer with optional video support
 Qimgv is an image viewer written in Qt5. It is fast, configurable
 and easy to use. It also provides optional video support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export QT_SELECT := 5

%:
	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%qimgv-$1.tar.gz%" \
 https://github.com/easymodo/qimgv/releases \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## qimgv 0.9.1-12+g0de3efc

=== debian/changelog ===
qimgv (0.9.1-12+g0de3efc-fix1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.
  * Move kimageformat-plugins to depends.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Tue, 10 Nov 2020 11:05:55 -0500

qimgv (0.9.1-12-g0de3efc-fix1-1easymodo2~eoan) eoan; urgency=medium

  * .

 -- Eugene G. <easymodofrf@gmail.com>  Fri, 22 May 2020 13:21:55 +0300

qimgv (0.9.1-12-g0de3efc-fix1-1easymodo2~focal) eoan; urgency=medium

  * 0.9.1-eoan

 -- Eugene G. <easymodofrf@gmail.com>  Fri, 22 May 2020 13:20:54 +0300

qimgv (0.9.1-12-g0de3efc-fix1-1easymodo2~focal) focal; urgency=medium

  * 0.9.1

 -- Eugene G. <easymodofrf@gmail.com>  Fri, 22 May 2020 13:15:32 +0300

qimgv (0.9.1-12-g0de3efc-fix1-1easymodo2~bionic) bionic; urgency=medium

  * 0.9.1

 -- Eugene G. <easymodofrf@gmail.com>  Fri, 22 May 2020 13:10:36 +0300

qimgv (0.9.1-12-g0de3efc-fix1-1easymodo1~bionic) bionic; urgency=medium

  * test

 -- Eugene G. <easymodofrf@gmail.com>  Fri, 22 May 2020 13:05:25 +0300

=== debian/control ===
Source: qimgv
Section: graphics
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Eugene G. <easymodofrf@gmail.com>
Build-Depends: debhelper (>= 10),
	gcc-8,
	g++-8,
	cmake, 
	pkg-config,
	qt5-default,
	libmpv-dev,
	libexiv2-dev,
	libopencv-dev,
	libopencv-imgproc-dev,
	libopencv-core-dev,
	libkf5windowsystem-dev,
Standards-Version: 4.1.4
Homepage: https://github.com/easymodo/qimgv
#Vcs-Git: git://github.com/easymodo/qimgv.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/qimgv.git;a=summary

Package: qimgv
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, kimageformat-plugins
Description: Image viewer with webm support
 Qt5 image viewer with optional video support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export CC=gcc-8
export CXX=g++-8

BUILDDIR=$(CURDIR)/build/
DESTDIR=$(CURDIR)/debian/qimgv/

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_clean:
	dh_clean
	rm -rf $(BUILDDIR)

override_dh_auto_configure:
	[ -d $(BUILDDIR) ] || mkdir $(BUILDDIR)
	cd $(BUILDDIR) && cmake ../ -DCMAKE_INSTALL_PREFIX=$(DESTDIR)/usr/ -DCMAKE_INSTALL_LIBDIR=lib

override_dh_auto_build:
	cd $(BUILDDIR) && $(MAKE) -j 4

override_dh_auto_install:
	dh_auto_install
	cd $(BUILDDIR) && $(MAKE) install

%:
	dh $@

.PHONY: override_dh_auto_configure override_dh_auto_install

## qimgv 1.0.2

=== CMakeLists.txt ===
# qimgv root
cmake_minimum_required(VERSION 3.13)
project(qimgv
    VERSION 1.0.2
    HOMEPAGE_URL "https://github.com/easymodo/qimgv"
    LANGUAGES CXX)

message(STATUS "Build configuration: " ${CMAKE_BUILD_TYPE})

if(IS_ABSOLUTE ${CMAKE_INSTALL_LIBDIR})
    set(QIMGV_PLUGIN_DIR "${CMAKE_INSTALL_LIBDIR}/qimgv")
else()
    set(QIMGV_PLUGIN_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/qimgv")
endif()

ADD_DEFINITIONS(-D_QIMGV_PLUGIN_DIR="${QIMGV_PLUGIN_DIR}")

message(STATUS "Plugin dir: " ${QIMGV_PLUGIN_DIR})

# check for gcc
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND
        CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0)
    message(FATAL_ERROR "\n!!! THIS PROJECT REQUIRES GCC 9.0 OR LATER !!!\n")
endif()

# AUTOMOC
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# USER OPTIONS
# Usage: cmake -DVIDEO_SUPPORT=ON [...]
option(EXIV2 "For reading/writing exif tags" ON)
option(VIDEO_SUPPORT "Enable video support" ON)
option(OPENCV_SUPPORT "Enable HQ scaling via OpenCV" ON)
option(KDE_SUPPORT "Support blur when using KDE" OFF)

# FIND PACKAGES
# test for qt5, use that if possible
find_package(Qt5 COMPONENTS Widgets QUIET)
if(Qt5_FOUND)
    find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core Widgets Svg PrintSupport)
else()
    find_package(QT NAMES Qt5 Qt6 REQUIRED COMPONENTS Core Widgets Svg Core5Compat PrintSupport OpenGLWidgets)
endif()

message(STATUS "Qt Version: " ${QT_VERSION})
if(QT_VERSION_MAJOR GREATER_EQUAL 6)
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Widgets Svg PrintSupport Core5Compat OpenGLWidgets)
else()
    find_package(Qt${QT_VERSION_MAJOR} 5.12 REQUIRED COMPONENTS Core Widgets Svg PrintSupport)
endif()

if(EXIV2)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Exiv2 REQUIRED IMPORTED_TARGET exiv2)
endif()

if(KDE_SUPPORT)
    find_package(KF5WindowSystem REQUIRED)
endif()

if(OPENCV_SUPPORT)
    find_package(PkgConfig REQUIRED)
    find_package(OpenCV REQUIRED core imgproc)
endif()

##############################################################

add_subdirectory(qimgv)

if(VIDEO_SUPPORT)
    add_subdirectory(plugins/player_mpv)
endif()

=== qimgv/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,11 @@
 include(GNUInstallDirs)
+
+set(CMAKE_VERBOSE_MAKEFILE ON)
+
+if(APPLE)
+    set(APPLE_ICON_NAME "qimgv.icns")
+    set(APPLE_ICON_PATH "distrib/${APPLE_ICON_NAME}")
+endif()
 
 # ADD EXECUTABLE
 add_executable(qimgv
@@ -6,11 +13,15 @@
     core.cpp
     main.cpp
     settings.cpp
+    themestore.cpp
     sharedresources.cpp
     shortcutbuilder.cpp
     proxystyle.cpp
+    macosapplication.cpp
     resources.qrc
-    qimgv.rc)
+    qimgv.rc
+    ${APPLE_ICON_PATH}
+)
 
 # ADD SOURCES
 add_subdirectory(components)
@@ -26,9 +37,9 @@
 set_target_properties(qimgv PROPERTIES CXX_EXTENSIONS OFF)
 
 # LINK STUFF
-target_link_libraries(qimgv PRIVATE Qt5::Core Qt5::Widgets Qt5::Concurrent)
-if(USING_LIBSTDCXX)
-    target_link_libraries(qimgv PRIVATE stdc++fs)
+target_link_libraries(qimgv PRIVATE Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Svg Qt${QT_VERSION_MAJOR}::PrintSupport)
+if(QT_VERSION_MAJOR GREATER_EQUAL 6)
+    target_link_libraries(qimgv PRIVATE Qt${QT_VERSION_MAJOR}::Core5Compat)
 endif()
 
 # OPTION DEFINITIONS, LINKING
@@ -42,6 +53,13 @@
 endif()
 if(VIDEO_SUPPORT)
     target_compile_definitions(qimgv PRIVATE USE_MPV)
+    if(WIN32)
+        ADD_DEFINITIONS(-D_QIMGV_PLUGIN_DIR="plugins")
+        ADD_DEFINITIONS(-D_QIMGV_PLAYER_PLUGIN="player_mpv.dll")
+    else()
+        ADD_DEFINITIONS(-D_QIMGV_PLUGIN_DIR="${QIMGV_PLUGIN_DIR}")
+        ADD_DEFINITIONS(-D_QIMGV_PLAYER_PLUGIN="player_mpv.so")
+    endif()
 endif()
 if(OPENCV_SUPPORT)
     target_link_libraries(qimgv PRIVATE ${OpenCV_LIBS})
@@ -59,7 +77,15 @@
         message(SEND_ERROR "You are using an unsupported Windows compiler! (Not MSVC or GCC)")
     endif(MSVC)
 elseif(APPLE)
-    set_target_properties(qimgv PROPERTIES MACOSX_BUNDLE YES)
+    set_target_properties(qimgv PROPERTIES
+        MACOSX_BUNDLE YES
+        MACOSX_BUNDLE_BUNDLE_NAME "qimgv"
+        MACOSX_BUNDLE_BUNDLE_VERSION "1.0.2"
+        MACOSX_BUNDLE_SHORT_VERSION_STRING "1.0.2"
+        MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/distrib/MyBundleInfo.plist.in
+        MACOSX_BUNDLE_ICON_FILE ${APPLE_ICON_NAME}
+    )
+    set_source_files_properties(${APPLE_ICON_PATH} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
 elseif(NOT UNIX)
     message(SEND_ERROR "You are on an unsupported platform! (Not Win32, Mac OS X or Unix)")
 endif()

=== plugins/player_mpv/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)
project(player_mpv
    DESCRIPTION "video player widget for qimgv (using mpv)"
    LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

set(QIMGV_LIBDIR "${CMAKE_INSTALL_LIBDIR}/qimgv")

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core Widgets)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Widgets)

find_package(PkgConfig REQUIRED)
pkg_check_modules(Mpv REQUIRED IMPORTED_TARGET mpv)

include(GNUInstallDirs)

add_library(player_mpv MODULE
    src/videoplayer.cpp
    src/mpvwidget.cpp
    src/videoplayermpv.cpp
    src/qthelper.hpp)

target_compile_features(player_mpv PRIVATE cxx_std_11)

target_link_libraries(player_mpv PRIVATE
    Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Widgets PkgConfig::Mpv)
if(QT_VERSION_MAJOR GREATER_EQUAL 6)
    target_link_libraries(player_mpv PRIVATE Qt${QT_VERSION_MAJOR}::OpenGLWidgets)
endif()

set_target_properties(player_mpv PROPERTIES
    CXX_EXTENSIONS OFF
    PREFIX "")

target_include_directories(player_mpv PRIVATE src)

if(WIN32)
    target_include_directories(player_mpv PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/mpv-dev/include)
    target_link_directories(player_mpv PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/mpv-dev/$<IF:$<EQUAL:${CMAKE_SIZEOF_VOID_P},8>,x86_64,i686>)
endif()

install(TARGETS player_mpv LIBRARY DESTINATION ${QIMGV_LIBDIR})

=== qimgv/gui/CMakeLists.txt ===
--- 
+++ 
@@ -27,11 +27,16 @@
     customwidgets/thumbnailwidget.cpp
     customwidgets/videoslider.cpp
     customwidgets/pushbuttonfocusind.cpp
+    customwidgets/styledcombobox.cpp
+    customwidgets/colorselectorbutton.cpp
+    customwidgets/entryinfoitem.cpp
 
+    dialogs/filereplacedialog.cpp
     dialogs/resizedialog.cpp
     dialogs/scripteditordialog.cpp
     dialogs/settingsdialog.cpp
     dialogs/shortcutcreatordialog.cpp
+    dialogs/printdialog.cpp
 
     overlays/changelogwindow.cpp
     overlays/controlsoverlay.cpp
@@ -54,6 +59,7 @@
     panels/croppanel/croppanel.cpp
     panels/mainpanel/mainpanel.cpp
     panels/mainpanel/thumbnailstrip.cpp
+    panels/mainpanel/thumbnailstripproxy.cpp
     panels/sidepanel/sidepanel.cpp
 
     panels/infobar/infobar.cpp
@@ -68,11 +74,11 @@
     folderview/foldergridview.cpp
     folderview/folderview.cpp
     folderview/folderviewproxy.cpp
-    folderview/thumbnailgridwidget.cpp
     folderview/filesystemmodelcustom.cpp
     folderview/treeviewcustom.cpp
     folderview/bookmarkswidget.cpp
     folderview/bookmarksitem.cpp
+    folderview/fvoptionspopup.cpp
 )
 
 # UI Files
@@ -80,10 +86,12 @@
 target_sources(qimgv PRIVATE
     contextmenu.ui
 
+    dialogs/filereplacedialog.ui
     dialogs/resizedialog.ui
     dialogs/scripteditordialog.ui
     dialogs/settingsdialog.ui
     dialogs/shortcutcreatordialog.ui
+    dialogs/printdialog.ui
 
     overlays/changelogwindow.ui
     overlays/copyoverlay.ui
@@ -100,4 +108,5 @@
     panels/infobar/infobar.ui
 
     folderview/folderview.ui
+    folderview/fvoptionspopup.ui
 )

=== debian/changelog ===
qimgv (1.0.2-2) unstable; urgency=medium

  * Team upload
  * Disable mpv support for now (Closes: #1024028)

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 28 Nov 2022 19:40:51 +0100

qimgv (1.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Update standards version to 4.6.0, no changes needed.
  * Add new build-dependency libqt5svg5-dev.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on cmake.

 -- Boyuan Yang <byang@debian.org>  Wed, 29 Sep 2021 21:00:36 -0400

=== debian/control ===
Source: qimgv
Section: graphics
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Standards-Version: 4.6.0
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libexiv2-dev,
 libkf5windowsystem-dev,
 libopencv-core-dev,
 libopencv-dev,
 libopencv-imgproc-dev,
 libqt5svg5-dev,
 pkg-config,
 qtbase5-dev (>= 5.9~),
Rules-Requires-Root: no
Homepage: https://github.com/easymodo/qimgv
Vcs-Git: https://salsa.debian.org/multimedia-team/qimgv.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/qimgv

Package: qimgv
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Qt5 image viewer with optional video support
 Qimgv is an image viewer written in Qt5. It is fast, configurable
 and easy to use. It also provides optional video support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export QT_SELECT := 5

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DVIDEO_SUPPORT=OFF

## qimgv 1.0.2%2Bgit20240112

=== debian/changelog ===
qimgv (1.0.2+git20240112-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:29:11 +1100

qimgv (1.0.2+git20240112-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:39:23 +0000

qimgv (1.0.2+git20240112-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Boyuan Yang <byang@debian.org>  Tue, 06 Feb 2024 10:29:47 -0500

qimgv (1.0.2+git20230814-1) unstable; urgency=medium

  * New upstream snapshot.
  * debian/patches/0001-Search-multiarch-dir-for-plugin-so-files.patch:
    Add patch to also search multiarch dirs when looking for plugin
    .so files. (Closes: #1041064)

 -- Boyuan Yang <byang@debian.org>  Fri, 03 Nov 2023 14:16:38 -0400

qimgv (1.0.2+git20230615-1) unstable; urgency=medium

  * New upstream snapshot.
  * debian/rules: Re-enable mpv support.
  * debian/control: Add new build-dep qttools5-dev, libfftw3-dev.

 -- Boyuan Yang <byang@debian.org>  Sun, 02 Jul 2023 20:04:11 -0400

## qimgv 1.0.2+git20230615

=== qimgv/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,28 @@
 if(APPLE)
     set(APPLE_ICON_NAME "qimgv.icns")
     set(APPLE_ICON_PATH "distrib/${APPLE_ICON_NAME}")
+endif()
+
+# TRANSLATIONS
+find_package(Qt${QT_VERSION_MAJOR} COMPONENTS LinguistTools)
+# Example of creating a new translation file.
+# 1. cd into qimgv directory and run:
+#   lupdate -recursive . -ts res/translations/qimgv_en_US.ts    [replace "en_US" with your locale]
+# 2. Add your .ts filename into TS_FILES list below
+# 3. Translate it with Qt Linguist
+set(TS_FILES
+    "zh_CN.ts"
+    "uk_UA.ts"
+)
+list(TRANSFORM TS_FILES PREPEND ${CMAKE_CURRENT_SOURCE_DIR}/res/translations/)
+set_source_files_properties(${TS_FILES} PROPERTIES OUTPUT_LOCATION ${PROJECT_BINARY_DIR}/qimgv/translations)
+
+# 1. Create 'qimgv_lupdate' target to update .ts files (needs to be called manually)
+# 2. Compile .ts > .qm
+if(${QT_VERSION_MAJOR} EQUAL 5)
+    add_custom_target(qimgv_lupdate COMMAND ${Qt5_LUPDATE_EXECUTABLE} -recursive
+        ${CMAKE_CURRENT_SOURCE_DIR} -ts ${TS_FILES})
+    qt5_add_translation(QM_FILES ${TS_FILES})
 endif()
 
 # ADD EXECUTABLE
@@ -21,7 +43,14 @@
     resources.qrc
     qimgv.rc
     ${APPLE_ICON_PATH}
+    ${QM_FILES}
 )
+
+# update .ts, compile .qm (qt6 case)
+if(${QT_VERSION_MAJOR} EQUAL 6)
+    qt_add_lupdate(qimgv TS_FILES ${TS_FILES})
+    qt_add_lrelease(qimgv TS_FILES ${TS_FILES})
+endif()
 
 # ADD SOURCES
 add_subdirectory(components)
@@ -39,7 +68,7 @@
 # LINK STUFF
 target_link_libraries(qimgv PRIVATE Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Svg Qt${QT_VERSION_MAJOR}::PrintSupport)
 if(QT_VERSION_MAJOR GREATER_EQUAL 6)
-    target_link_libraries(qimgv PRIVATE Qt${QT_VERSION_MAJOR}::Core5Compat)
+    target_link_libraries(qimgv PRIVATE Qt${QT_VERSION_MAJOR}::OpenGLWidgets)
 endif()
 
 # OPTION DEFINITIONS, LINKING
@@ -72,7 +101,11 @@
         set_target_properties(qimgv PROPERTIES WIN32_EXECUTABLE ON)
         target_link_options(qimgv PRIVATE "/ENTRY:mainCRTStartup")
     elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
-        target_link_options(qimgv PRIVATE "-mwindows") # Not tested
+        target_link_options(qimgv PRIVATE "-mwindows")
+    elseif(CMAKE_CXX_COMPILER_ID MATCHES ".*Clang")
+        set(CMAKE_CXX_FLAGS "$ENV{CMAKE_CXX_FLAGS} -Wno-shift-negative-value")
+        set(CMAKE_EXE_LINKER_FLAGS "$ENV{CMAKE_EXE_LINKER_FLAGS} -fuse-ld=lld")
+        target_link_options(qimgv PRIVATE "-mwindows")
     else()
         message(SEND_ERROR "You are using an unsupported Windows compiler! (Not MSVC or GCC)")
     endif(MSVC)
@@ -91,8 +124,7 @@
 endif()
 
 ## INSTALLATION
-install(TARGETS qimgv
-    DESTINATION bin)
+install(TARGETS qimgv DESTINATION bin)
 
 # .desktop
 install(FILES distrib/qimgv.desktop
@@ -105,3 +137,25 @@
 endforeach()
 install(FILES distrib/hicolor/scalable/apps/qimgv.svg
     DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/icons/hicolor/scalable/apps)
+
+# AppData manifest
+install(FILES distrib/qimgv.appdata.xml DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/metainfo)
+
+# Install internationalization language files
+if(WIN32)
+    install(DIRECTORY "${PROJECT_BINARY_DIR}/qimgv/translations" DESTINATION "${CMAKE_INSTALL_BINDIR}")
+else()
+    ADD_DEFINITIONS(-DTRANSLATIONS_PATH="${CMAKE_INSTALL_FULL_DATAROOTDIR}/qimgv/translations")
+    install(DIRECTORY "${PROJECT_BINARY_DIR}/qimgv/translations" DESTINATION "${CMAKE_INSTALL_FULL_DATAROOTDIR}/qimgv")
+endif()
+
+# uninstall target
+if(NOT TARGET uninstall)
+  configure_file(
+    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
+    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
+    IMMEDIATE @ONLY)
+
+  add_custom_target(uninstall
+    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
+endif()

=== debian/control ===
--- 
+++ 
@@ -4,18 +4,21 @@
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Boyuan Yang <byang@debian.org>,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
  libexiv2-dev,
+ libfftw3-dev,
  libkf5windowsystem-dev,
+ libmpv-dev,
  libopencv-core-dev,
  libopencv-dev,
  libopencv-imgproc-dev,
  libqt5svg5-dev,
  pkg-config,
  qtbase5-dev (>= 5.9~),
+ qttools5-dev,
 Rules-Requires-Root: no
 Homepage: https://github.com/easymodo/qimgv
 Vcs-Git: https://salsa.debian.org/multimedia-team/qimgv.git

## qimgv 1.0.2+git20240112

=== qimgv/CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,8 @@
 set(TS_FILES
     "zh_CN.ts"
     "uk_UA.ts"
+    "es_ES.ts"
+    "de_DE.ts"
 )
 list(TRANSFORM TS_FILES PREPEND ${CMAKE_CURRENT_SOURCE_DIR}/res/translations/)
 set_source_files_properties(${TS_FILES} PROPERTIES OUTPUT_LOCATION ${PROJECT_BINARY_DIR}/qimgv/translations)

=== qimgv/gui/CMakeLists.txt ===
--- 
+++ 
@@ -19,9 +19,7 @@
     customwidgets/overlaywidget.cpp
     customwidgets/pathselectormenuitem.cpp
     customwidgets/sidepanelwidget.cpp
-    customwidgets/slidehpanel.cpp
     customwidgets/slidepanel.cpp
-    customwidgets/slidevpanel.cpp
     customwidgets/spinboxinputfix.cpp
     customwidgets/thumbnailview.cpp
     customwidgets/thumbnailwidget.cpp
@@ -30,6 +28,7 @@
     customwidgets/styledcombobox.cpp
     customwidgets/colorselectorbutton.cpp
     customwidgets/entryinfoitem.cpp
+    customwidgets/ssidebar.cpp
 
     dialogs/filereplacedialog.cpp
     dialogs/resizedialog.cpp

=== debian/changelog ===
qimgv (1.0.2+git20240112-2build2) plucky; urgency=medium

  * No-change rebuild for opencv 4.10.0.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 19 Feb 2025 08:47:48 +0000

qimgv (1.0.2+git20240112-2build1) plucky; urgency=medium

  * No-change rebuild for libexiv2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 01 Nov 2024 12:22:22 +0000

qimgv (1.0.2+git20240112-2) unstable; urgency=medium

  * QA upload.
  * Orphan the package.

 -- Boyuan Yang <byang@debian.org>  Fri, 08 Mar 2024 09:05:34 -0500

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,7 @@
 Source: qimgv
 Section: graphics
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
-Uploaders:
- Boyuan Yang <byang@debian.org>,
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Standards-Version: 4.6.2
 Build-Depends:
  cmake,
@@ -21,8 +19,8 @@
  qttools5-dev,
 Rules-Requires-Root: no
 Homepage: https://github.com/easymodo/qimgv
-Vcs-Git: https://salsa.debian.org/multimedia-team/qimgv.git
-Vcs-Browser: https://salsa.debian.org/multimedia-team/qimgv
+Vcs-Git: https://salsa.debian.org/debian/qimgv.git
+Vcs-Browser: https://salsa.debian.org/debian/qimgv
 
 Package: qimgv
 Architecture: any

## qimgv 1.0.2+git20250303

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,16 +6,6 @@
     LANGUAGES CXX)
 
 message(STATUS "Build configuration: " ${CMAKE_BUILD_TYPE})
-
-if(IS_ABSOLUTE ${CMAKE_INSTALL_LIBDIR})
-    set(QIMGV_PLUGIN_DIR "${CMAKE_INSTALL_LIBDIR}/qimgv")
-else()
-    set(QIMGV_PLUGIN_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/qimgv")
-endif()
-
-ADD_DEFINITIONS(-D_QIMGV_PLUGIN_DIR="${QIMGV_PLUGIN_DIR}")
-
-message(STATUS "Plugin dir: " ${QIMGV_PLUGIN_DIR})
 
 # check for gcc
 if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND
@@ -35,19 +25,25 @@
 option(VIDEO_SUPPORT "Enable video support" ON)
 option(OPENCV_SUPPORT "Enable HQ scaling via OpenCV" ON)
 option(KDE_SUPPORT "Support blur when using KDE" OFF)
+if(UNIX AND NOT APPLE)
+    set(QT_EXTERN_PATH "" CACHE STRING "Tell compile external QT path, example: (/opt/Qt/6.2.0/gcc_64)")
+    string(COMPARE EQUAL "${QT_EXTERN_PATH}" "" result)
+    if (NOT result)
+        set(CMAKE_INSTALL_RPATH "${QT_EXTERN_PATH}/lib")
+    endif()
+endif()
 
 # FIND PACKAGES
-# test for qt5, use that if possible
 find_package(Qt5 COMPONENTS Widgets QUIET)
 if(Qt5_FOUND)
     find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core Widgets Svg PrintSupport)
 else()
-    find_package(QT NAMES Qt5 Qt6 REQUIRED COMPONENTS Core Widgets Svg Core5Compat PrintSupport OpenGLWidgets)
+    find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core Widgets Svg PrintSupport OpenGLWidgets)
 endif()
 
 message(STATUS "Qt Version: " ${QT_VERSION})
 if(QT_VERSION_MAJOR GREATER_EQUAL 6)
-    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Widgets Svg PrintSupport Core5Compat OpenGLWidgets)
+    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Widgets Svg PrintSupport OpenGLWidgets)
 else()
     find_package(Qt${QT_VERSION_MAJOR} 5.12 REQUIRED COMPONENTS Core Widgets Svg PrintSupport)
 endif()

=== qimgv/CMakeLists.txt ===
--- 
+++ 
@@ -19,6 +19,7 @@
     "uk_UA.ts"
     "es_ES.ts"
     "de_DE.ts"
+    "fr_FR.ts"
 )
 list(TRANSFORM TS_FILES PREPEND ${CMAKE_CURRENT_SOURCE_DIR}/res/translations/)
 set_source_files_properties(${TS_FILES} PROPERTIES OUTPUT_LOCATION ${PROJECT_BINARY_DIR}/qimgv/translations)

=== qimgv/gui/CMakeLists.txt ===
--- 
+++ 
@@ -38,6 +38,7 @@
     dialogs/printdialog.cpp
 
     overlays/changelogwindow.cpp
+    overlays/clickzoneoverlay.cpp
     overlays/controlsoverlay.cpp
     overlays/copyoverlay.cpp
     overlays/cropoverlay.cpp

=== qimgv/tests/CMakeLists.txt ===
enable_testing()
find_package(Qt5 REQUIRED COMPONENTS Test Widgets)

include_directories(${CMAKE_SOURCE_DIR})

add_executable(unit_tests test_mapoverlay.cpp)
target_link_libraries(unit_tests PRIVATE Qt5::Test Qt5::Widgets)

add_test(NAME QUI_TEST COMMAND unit_tests)

=== debian/changelog ===
qimgv (1.0.2+git20250303-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot. (Closes: #1078062)

 -- Boyuan Yang <byang@debian.org>  Thu, 10 Apr 2025 20:06:29 -0400

## qimgv 1.0.2+git20250905

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,8 @@
 option(VIDEO_SUPPORT "Enable video support" ON)
 option(OPENCV_SUPPORT "Enable HQ scaling via OpenCV" ON)
 option(KDE_SUPPORT "Support blur when using KDE" OFF)
+option(USE_QT5 "Build with Qt5 if available" ON)
+
 if(UNIX AND NOT APPLE)
     set(QT_EXTERN_PATH "" CACHE STRING "Tell compile external QT path, example: (/opt/Qt/6.2.0/gcc_64)")
     string(COMPARE EQUAL "${QT_EXTERN_PATH}" "" result)
@@ -34,11 +36,20 @@
 endif()
 
 # FIND PACKAGES
-find_package(Qt5 COMPONENTS Widgets QUIET)
-if(Qt5_FOUND)
-    find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core Widgets Svg PrintSupport)
-else()
-    find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core Widgets Svg PrintSupport OpenGLWidgets)
+if(USE_QT5) # Try Qt5 first if USE_QT5 is set
+    find_package(Qt5 COMPONENTS Widgets QUIET)
+    if(Qt5_FOUND)
+        find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core Widgets Svg PrintSupport)
+    else()
+        find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core Widgets Svg PrintSupport OpenGLWidgets)
+    endif()
+else() # Try Qt6 otherwise
+    find_package(Qt6 COMPONENTS Widgets QUIET)
+    if(Qt6_FOUND)
+        find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core Widgets Svg PrintSupport OpenGLWidgets)
+    else()
+        find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core Widgets Svg PrintSupport)
+    endif()
 endif()
 
 message(STATUS "Qt Version: " ${QT_VERSION})
@@ -54,7 +65,7 @@
 endif()
 
 if(KDE_SUPPORT)
-    find_package(KF5WindowSystem REQUIRED)
+    find_package(KF6WindowSystem REQUIRED)
 endif()
 
 if(OPENCV_SUPPORT)

=== qimgv/CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,7 @@
     "es_ES.ts"
     "de_DE.ts"
     "fr_FR.ts"
+    "tr_TR.ts"
 )
 list(TRANSFORM TS_FILES PREPEND ${CMAKE_CURRENT_SOURCE_DIR}/res/translations/)
 set_source_files_properties(${TS_FILES} PROPERTIES OUTPUT_LOCATION ${PROJECT_BINARY_DIR}/qimgv/translations)
@@ -80,7 +81,7 @@
     target_compile_definitions(qimgv PRIVATE USE_EXIV2)
 endif()
 if(KDE_SUPPORT)
-    target_link_libraries(qimgv PRIVATE KF5::WindowSystem)
+    target_link_libraries(qimgv PRIVATE KF6::WindowSystem)
     target_compile_definitions(qimgv PRIVATE USE_KDE_BLUR)
 endif()
 if(VIDEO_SUPPORT)

=== plugins/player_mpv/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)
project(player_mpv
    DESCRIPTION "video player widget for qimgv (using mpv)"
    LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

# only export CreatePlayerWidget function
ADD_DEFINITIONS(-DQIMGV_PLAYER_MPV_LIBRARY)

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core Widgets)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Widgets)

if(NOT WIN32)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Mpv REQUIRED IMPORTED_TARGET mpv)
endif()

include(GNUInstallDirs)

add_library(player_mpv MODULE
    src/videoplayer.cpp
    src/mpvwidget.cpp
    src/videoplayermpv.cpp
    src/qthelper.hpp)

target_compile_features(player_mpv PRIVATE cxx_std_11)

if(WIN32)
    target_link_libraries(player_mpv PRIVATE
        Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Widgets Mpv)
else()
    target_link_libraries(player_mpv PRIVATE
        Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Widgets PkgConfig::Mpv)
endif()

if(QT_VERSION_MAJOR GREATER_EQUAL 6)
    target_link_libraries(player_mpv PRIVATE Qt${QT_VERSION_MAJOR}::OpenGLWidgets)
endif()

set_target_properties(player_mpv PROPERTIES
    CXX_EXTENSIONS OFF
    PREFIX "")

target_include_directories(player_mpv PRIVATE src)

if(WIN32)
    target_include_directories(player_mpv PRIVATE
        ${MPV_DIR}/include)
    target_link_directories(player_mpv PRIVATE
        ${MPV_DIR}/lib/$<IF:$<EQUAL:${CMAKE_SIZEOF_VOID_P},8>,x86_64,i686>)
endif()

if(WIN32)
    install(TARGETS player_mpv LIBRARY DESTINATION "${CMAKE_INSTALL_BINDIR}/plugins")
else()
    install(TARGETS player_mpv LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}/qimgv")
endif()

=== qimgv/components/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,12 @@
 
 )
 
-if(UNIX)
+if(APPLE)
+    #target_sources(qimgv PRIVATE
+    #    directorymanager/watchers/linux/linuxfsevent.cpp
+    #    directorymanager/watchers/linux/linuxwatcher.cpp
+    #    directorymanager/watchers/linux/linuxworker.cpp)
+elseif(UNIX)
     target_sources(qimgv PRIVATE
         directorymanager/watchers/linux/linuxfsevent.cpp
         directorymanager/watchers/linux/linuxwatcher.cpp

=== qimgv/tests/CMakeLists.txt ===
enable_testing()
find_package(Qt6 REQUIRED COMPONENTS Test Widgets)

include_directories(${CMAKE_SOURCE_DIR})

add_executable(unit_tests test_mapoverlay.cpp)
target_link_libraries(unit_tests PRIVATE Qt6::Test Qt6::Widgets)

add_test(NAME QUI_TEST COMMAND unit_tests)

=== qimgv/utils/CMakeLists.txt ===
## SOURCES FOR QIMGV UTILITY CLASSES

target_sources(qimgv PRIVATE
    actions.cpp
    cmdoptionsrunner.cpp
    imagefactory.cpp
    imagelib.cpp
    inputmap.cpp
    randomizer.cpp
    script.cpp
    sleep.cpp
    stuff.cpp
    wallpapersetter.cpp
    fileoperations.cpp
)

=== qimgv/3rdparty/QtOpenCV/CMakeLists.txt ===
target_sources(qimgv PRIVATE
    cvmatandqimage.cpp
)

=== debian/changelog ===
qimgv (1.0.2+git20250905-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot.

 -- Boyuan Yang <byang@debian.org>  Wed, 24 Sep 2025 14:53:15 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: graphics
 Priority: optional
 Maintainer: Debian QA Group <packages@qa.debian.org>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
@@ -14,7 +14,7 @@
  libopencv-dev,
  libopencv-imgproc-dev,
  libqt5svg5-dev,
- pkg-config,
+ pkgconf,
  qtbase5-dev (>= 5.9~),
  qttools5-dev,
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -8,8 +8,9 @@
 
 export QT_SELECT := 5
 
+include /usr/share/dpkg/architecture.mk
+# For CMake recognizing this variable
+export DEB_HOST_MULTIARCH
+
 %:
 	dh $@
-
-override_dh_auto_configure:
-	dh_auto_configure -- -DVIDEO_SUPPORT=OFF

=== debian/watch ===
version=4
opts="filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,searchmode=plain" \
             https://api.github.com/repos/easymodo/qimgv/tags?per_page=100 \
             https://api.github.com/repos/easymodo/qimgv/tarball/refs/tags/@ANY_VERSION@

## qimgv 1.0.2+git20260119

=== qimgv/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,7 @@
     "de_DE.ts"
     "fr_FR.ts"
     "tr_TR.ts"
+    "ja_JP.ts"
 )
 list(TRANSFORM TS_FILES PREPEND ${CMAKE_CURRENT_SOURCE_DIR}/res/translations/)
 set_source_files_properties(${TS_FILES} PROPERTIES OUTPUT_LOCATION ${PROJECT_BINARY_DIR}/qimgv/translations)

=== debian/changelog ===
qimgv (1.0.2+git20260119-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot.
  * Switch to build with Qt6.

 -- Boyuan Yang <byang@debian.org>  Tue, 03 Mar 2026 21:13:10 -0500

=== debian/control ===
Source: qimgv
Section: graphics
Maintainer: Debian QA Group <packages@qa.debian.org>
Standards-Version: 4.7.3
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libexiv2-dev,
 libfftw3-dev,
 libkf6windowsystem-dev,
 libmpv-dev,
 libopencv-core-dev,
 libopencv-dev,
 libopencv-imgproc-dev,
 pkgconf,
 qt6-base-dev,
 qt6-svg-dev,
 qt6-tools-dev,
Homepage: https://github.com/easymodo/qimgv
Vcs-Git: https://salsa.debian.org/debian/qimgv.git
Vcs-Browser: https://salsa.debian.org/debian/qimgv

Package: qimgv
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Qt image viewer with optional video support
 Qimgv is an image viewer written in Qt. It is fast, configurable
 and easy to use. It also provides optional video support.

=== debian/rules ===
--- 
+++ 
@@ -6,11 +6,12 @@
 # see FEATURE AREAS in dpkg-buildflags(1)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
-export QT_SELECT := 5
-
 include /usr/share/dpkg/architecture.mk
 # For CMake recognizing this variable
 export DEB_HOST_MULTIARCH
 
 %:
 	dh $@
+
+override_dh_auto_configure:
+	dh_auto_configure -- -DUSE_QT5=OFF
